---
title: RTCDataChannel.onmessage
slug: Web/API/RTCDataChannel/onmessage
tags:
  - Event Handler
  - Experimental
  - Property
  - RTCDataChannel
  - Reference
  - WebRTC
  - onmessage
---
<p>{{APIRef("WebRTC")}}{{SeeCompatTable}}</p>

<p>The <code><strong>RTCDataChannel.onmessage</strong></code> property stores an {{domxref("EventHandler")}} which specifies a function to be called when the {{event("message")}} event is fired on the channel. This event is represented by the {{domxref("MessageEvent")}} interface. This event is sent to the channel when a message is received from the other peer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCDataChannel</em>.onmessage = <em>function</em>;</pre>

<h3 id="Value">Value</h3>

<p>A function which the browser will call to handle the {{event("message")}} event. The function receives as its sole input parameter a {{domxref("MessageEvent")}} object describing the event.</p>

<h2 id="Example">Example</h2>

<p>This code snippet creates a peer connection, adds a data channel to it, and starts creating new {{HTMLElement("p")}} (paragraph) elements each time a message arrives, with the message's contents displayed inside it. The new elements are then attached to the end of the document.</p>

<pre class="brush: js">let pc = new RTCPeerConnection();
let dc = pc.createDataChannel();

dc.onmessage = function(event) {
  var el = document.createElement("p");
  var txtNode = document.createTextNode(event.data);

  el.appendChild(txtNode);
  receiveBox.appendChild(el);
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcdatachannel-onmessage', 'RTCDataChannel.onmessage') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.onmessage")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a></li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCDataChannel")}}</li>
 <li>The {{event("message")}} event and its type, {{domxref("MessageEvent")}}.</li>
</ul>
